#include "cuda.h"
#include <stdio.h>

__global__ void add( float *x, int n ) {

int i = threadIdx.x + blockIdx.x * blockDim.x;

x[i] = x[i] + 1.1;

}

int main()
{
int n = 256; //vector length
float *cpu_x;
float *dev_x;
cpu_x = (float*)calloc(n,sizeof(float));

printf("x[24]=%lf before GPU.\n",cpu_x[24]);

cudaMalloc((void**)&dev_x,n*sizeof(float));

cudaMemcpy(cpu_x,dev_x,n*sizeof(float),cudaMemcpyHostToDevice);

add<<<8,32>>>(dev_x,n);

cudaMemcpy(cpu_x,dev_x,n*sizeof(float),cudaMemcpyDeviceToHost);

printf("x[24]=%lf after GPU.\n",cpu_x[24]);

printf("Successfully added to the vector X.");
fflush(stdout);

free(cpu_x);

return(0);
}
